<!-- Example widget for demonstration  -->
<script lang="ts">
	import { onMount } from 'svelte';
	import { page } from '$app/stores';
	import { ws } from '$lib/config';
	import { teams } from '$lib/teams';
	import Counter from '../Counter..svelte';
	import ReconnectingWebSocket from 'reconnecting-websocket';

	// One might use this widget with a GET param for the streamer ID
	// ?streamer=1

	// This URI should work : http://localhost:5173/cagnotte-ekip?team=1

	type Team = {
		name: string;
		color: string;
	};

	const teamId = $page.url.searchParams.get('team');
	const team: Team | null = teamId ? teams[+teamId] : null;

	let teamPot: number;

	onMount(async () => {
		// Start WS
		const socket = new ReconnectingWebSocket(ws());

		socket.addEventListener('open', function (event) {
			socket.send(JSON.stringify({ op: 'sub', msg: `teams.${teamId}.pot` }));
		});

		socket.addEventListener('message', function (event) {
			let data = JSON.parse(event.data);

			switch (data.r) {
				case `teams.${teamId}.pot`:
					teamPot = data.d.pot;
					// console.log('Received update', data);
					break;
				case `refresh`:
					// Refresh the page
					setTimeout(() => {
						window.location.reload();
					}, Math.random() * 1000);
					break;
			}
		});

		// // Uncomment this to test the widget without the backend
		// let p = 0
		// setInterval(() => {
		// 	p += Math.random() * 1000;
		// 	updatePot(p);
		// }, 1200);
	});
</script>

<div class="rounded-lg flex flex-col justify-center items-center gap-1">
	<h1 class="team-title text-2xl text-white fredoka flex gap-2">
		Team <p style:color={team?.color}>
			{team?.name}
		</p>
	</h1>
	<div class="background-frame flex flex-row text-3xl justify-center items-center text-white">
		<div class="flex flex-row text-3xl red-hat">
			<div class="flex flex-row text-3xl red-hat">
				<Counter amount={teamPot} /> €
			</div>
		</div>
	</div>
</div>

<style lang="scss">
	@import url('https://fonts.googleapis.com/css2?family=Red+Hat+Mono:wght@700&display=swap');
	@import url('https://fonts.googleapis.com/css2?family=Fredoka:wght@300..700&display=swap');
	.red-hat {
		font-family: 'Red Hat Mono', monospace;
		font-optical-sizing: auto;
		font-weight: 700;
		font-style: normal;
	}
	.fredoka {
		font-family: 'Fredoka', sans-serif;
		font-optical-sizing: auto;
		font-weight: 700;
		font-style: normal;
		font-variation-settings: 'wdth' 100;
	}

	.background-frame {
		padding: 4px 16px;
		min-width: 250px;
		position: relative;
		box-sizing: border-box;
		$border: 5px;
		color: #fff;
		background: #444;
		background-clip: padding-box; /* !importanté */
		border: solid $border transparent; /* !importanté */
		border-radius: 30px;

		&:before {
			content: '';
			position: absolute;
			top: 0;
			right: 0;
			bottom: 0;
			left: 0;
			z-index: -1;
			margin: -$border; /* !importanté */
			border-radius: inherit; /* !importanté */
			background: linear-gradient(to right, red, orange);
		}
	}
	.team-title {
		background: #444;
		padding: 0 10px;
		border-radius: 30px;
	}
</style>
